#FROM https://github.com/cvjena/nice-core/blob/master/cmake/FindMATIO.cmake
# Find the MATIO headers and library.
#
#  MATIO_INCLUDE_DIRS - where to find matio.h, etc.
#  MATIO_LIBRARIES    - List of libraries.
#  MATIO_FOUND        - True if matio found.

FIND_PATH(MATIO_INCLUDE_DIR NAMES matio.h PATHS ${FRAMEWORK_EXTENSION_FOLDER}/include/ $ENV{HOME}/include)
FIND_LIBRARY(MATIO_LIBRARY NAMES matio${ARCH_TYPE} libmatio${ARCH_TYPE} matio libmatio PATHS ${FRAMEWORK_EXTENSION_FOLDER}/lib/ $ENV{HOME}/lib)

MARK_AS_ADVANCED(MATIO_INCLUDE_DIR)
MARK_AS_ADVANCED(MATIO_LIBRARY)

# handle the QUIETLY and REQUIRED arguments and set MATIO_FOUND to TRUE if 
# all listed variables are TRUE
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(MATIO DEFAULT_MSG MATIO_LIBRARY MATIO_INCLUDE_DIR)

IF(MATIO_FOUND)
  SET(MATIO_LIBRARIES ${MATIO_LIBRARY} ${HDF5_LIBRARIES})
  SET(MATIO_INCLUDE_DIRS ${MATIO_INCLUDE_DIR} ${HDF5_INCLUDE_DIR})
ELSE(MATIO_FOUND)
  SET(MATIO_LIBRARIES)
  SET(MATIO_INCLUDE_DIRS)
ENDIF(MATIO_FOUND)
